//AntiTweak by {PiN}Kev - Feb, 2004
//Stop the bad tweaks such as big flag glow, big powerups, etc. that are loaded either through set commands or .u packages.
//Updated in 2007 to include: 
//- other hidden and glowing tweaks.  
//- anti fast weapon switch
//- kills empty weapons on the level so no more picking up empty weaps
//- ability to toggle death sounds on/off



class AntiTweak extends mutator;

var string version;

//Server vars
var private int serverTickCount;
var private canvas can;
var private weapon w;
var private AntiTweakLog ATLog;

//Vars replicated from server to client
var private bool bVarsSet;
var private float FlagltRad, FlagDrawScale, RedFlagLR, RedFlagDS, TournPlayerLR;
var private bool bWaterInvis, bRocketPuffHidden, bRocketTrailHidden, bUtSmokeTrail;

//UPDATES -------------------------------------------------------------------------------------------------
var private float UTSmokeTrailDS, ShockBeamLifeSpan, ShockBeamDS, PBoltDS, starterBoltDS;
var private mesh PBoltMesh, StarterBoltMesh, shockBeamMesh;
var private texture PlasmaHitTexture;
var private byte SBEffectLightType, enhancedRespawnDrawType, EnhancedRespawnLightEffect, TransTargetSoundRadius,TransTargetLightType, TransTargetLightEffect;
var private float enhancedRespawnLifeSpan, enhancedRespawnLightRadius, TransTargetLightRadius, TransTargetLightBrightness;
var private bool playerBUnlit; 
var private texture transeffectTexture;
var private bool bFireWetTextureInvis;
var private bool bTextureTransparent;

var private float SBDS, AmpDS, DeemerDS, KegDS, BootsDS, ArmorDS, invisDS;
var private mesh flagMesh, sbmesh, ampmesh, deemermesh, kegMesh, armorMesh, bootsMesh, invisMesh;


//Client vars
var private int tickCount, yTCount;
var private bool bGotP, bChecked;
var private playerpawn p;
var private string ySpeed; //mousey speed, default is "6"
var private bool bJustTossedWeapon;
var private bool bDeathsSent;

replication { 
    reliable if (Role==Role_Authority) FlagLtRad, FlagDrawScale, RedFlagLR, RedFlagDS, TournPlayerLR, bWaterInvis, 
                                       SBDS, AmpDS, DeemerDS, KegDS, BootsDS, ArmorDS, flagMesh, sbmesh, ampmesh, 
                                       deemermesh, kegMesh, armorMesh, bootsMesh, invisDS, invisMesh, bRocketPuffHidden, 
                                       bRocketTrailHidden, bUTSmokeTrail, 
                                       //UPDATES ----------------------
                                       UTSmokeTrailDS, ShockBeamLifeSpan, ShockBeamDS, PBoltDS, starterBoltDS, PBoltMesh, StarterBoltMesh, PlasmaHitTexture,
                                       SBEffectLightType, enhancedRespawnDrawType, EnhancedRespawnLightEffect,enhancedRespawnLifeSpan, enhancedRespawnLightRadius,
                                       playerBunlit, transeffectTexture, bFireWetTextureInvis, shockBeamMesh, TransTargetSoundRadius, TransTargetLightRadius, TransTargetLightType,
                                       TransTargetLightEffect, TransTargetLightBrightness, bTextureTransparent;
                                       
}

function postBeginPlay() {
    
    level.game.registerMessageMutator(self);
    ATlog = spawn(class'AntiTweakLog');
}

function setVars() {
    local ut_shieldbelt sb;
    local udamage amp;
    local warheadlauncher deemer;
    local healthpack keg;
    local ctfflag flag;
    local ut_invisibility invis;
    local armor2 armor;
    local ut_jumpboots boots;
    
    
    foreach allactors(class'ut_shieldBelt', sb) {
        SBDS = sb.DrawScale; 
        SBMesh = sb.Mesh;
        break;
    }
    foreach allactors(class'udamage', amp) {
        AmpDS = Amp.DrawScale;
        AmpMesh = Amp.Mesh;
        break;
    }
    foreach allactors(class'warheadlauncher', deemer) {
        DeemerDS = Deemer.DrawScale;
        DeemerMesh = Deemer.Mesh;
        break;
    }
    foreach allactors(class'healthPack', Keg) {
        kegDS = keg.DrawScale;
        kegMesh = keg.Mesh;
        break;
    }
    foreach allactors(class'ut_invisibility', invis) {
        invisDS = invis.DrawScale;
        invisMesh = invis.Mesh;
        break;
    }
    foreach allactors(class'armor2', armor) {
        armorDS = armor.DrawScale;
        armorMesh = armor.Mesh;
        break;
    }
    foreach allactors(class'ut_jumpboots', boots) {
        bootsDS = boots.DrawScale;
        bootsMesh = boots.Mesh;
        break;
    }
    foreach allactors(class'ctfflag', flag) {
        flagDrawScale = flag.DrawScale;
        flagMesh = flag.Mesh;
        flagLtRad = flag.LightRadius;
        break;
    }
    
    bRocketPuffHidden = class'ut_spriteSmokePuff'.default.bHidden;
    bRocketTrailHidden = class'LightSmokeTrail'.default.bHidden;
    bUtSmokeTrail = class'utSmokeTrail'.default.bHidden;
    UTSmokeTrailDS = class'utSmokeTrail'.default.drawScale;
    bWaterInvis = class'fire.waterTexture'.default.bInvisible;
    bFireWetTextureInvis = class'fire.wetTexture'.default.bInvisible;
    
    ShockBeamLifeSpan =  class'ShockBeam'.default.lifespan;
    ShockBeamDS =  class'ShockBeam'.default.drawScale;
    ShockBeamMesh = class'ShockBeam'.default.mesh;
    
    PBoltDS = class'pbolt'.default.drawScale;
    PBoltMesh = class'pbolt'.default.Mesh;
    starterBoltDS = class'starterbolt'.default.drawScale;
    StarterBoltMesh = class'starterbolt'.default.mesh;
    PlasmaHitTexture = class'plasmaHit'.default.texture;
    
    SbEffectLightType = class'UT_shieldBeltEffect'.default.lightType;
    
    enhancedRespawnDrawType = class'enhancedRespawn'.default.drawType;
    enhancedRespawnLifeSpan = class'enhancedRespawn'.default.lifespan;
    EnhancedRespawnLightEffect = class'enhancedRespawn'.default.LightEffect;
    enhancedRespawnLightRadius = class'enhancedRespawn'.default.lightRadius;
    
    transeffectTexture = class'translocouteffect'.default.texture;
    
    playerBUnlit = class'tmale1'.default.bunlit;
    
    transTargetSoundradius = class'Translocatortarget'.default.soundradius;
    transTargetLightRadius = class'Translocatortarget'.default.lightRadius;
    transTargetLightType = class'Translocatortarget'.default.lightType;
    transTargetLightEffect = class'Translocatortarget'.default.lightEffect;
    TransTargetLightBrightness = class'translocatortarget'.default.lightBrightness;
    
    bTextureTransparent = class'texture'.default.bTransparent;
}

static final function string ReplaceText(coerce string Text, coerce string Replace, coerce string With)
{
    local int i;
    local string Output;
    
    i = InStr(Text, Replace);
    while (i != -1) {   
        Output = Output $ Left(Text, i) $ With;
        Text = Mid(Text, i + Len(Replace)); 
        i = InStr(Text, Replace);
    }
    Output = Output $ Text;
    return Output;
}

function ATLogThis(string str, string serverName) { 
    local string parts[]; 
    
    ATlog.StartLog();
    ATLog.logEventString("Server Name: " $ serverName);
    ATlog.logEventString(str);   
    ATlog.stopLog();
}

function Mutate(string MutateStr, playerpawn sender) {
    local string tweakstr, address,ip;
    local tournamentplayer tp;
    if (left(mutateStr, 9) ~= "AntiTweak") {
         if (mid(mutateStr, 10, 9) ~= "broadcast") {
             if (level.game.numPlayers >= 1) {
                 tweakstr = right(mutateStr, len(mutateStr)-20);
                 address = sender.getPlayerNetworkAddress();
                 
                 sender.clientmessage("--------------------------------------------------");
                 sender.clientmessage(tweakstr $ " detected.");
                 sender.clientmessage("Please restart UT and rejoin without the tweak.");
                 sender.clientmessage("--------------------------------------------------");         
                 sender.destroy();
                 
                 if (address!="") ip=left(address,instr(address,":"));
                 else ip="0.0.0.0";         
                 
                 broadcastmessage(tweakstr);
                 ATLogThis(tweakstr $ " (IP Address: " $ ip $ ")", level.game.gameReplicationInfo.serverName);
              }
         }
         else if (mid(mutateStr,10,4) ~= "info") {
             sender.clientmessage("AntiTweak Version " $ version $ " by {PiN}Kev");
             sender.clientmessage("This mod blocks the following big tweaks:");
             sender.clientmessage("-- No Smoke");
             sender.clientmessage("-- Big Flag Glow");
             sender.clientmessage("-- Big Flag Sizes");
             sender.clientmessage("-- Big FC Glow");
             sender.clientmessage("-- Huge Powerups (can be seen through walls)");
             sender.clientmessage("-- No Water");
             sender.clientmessage("-- Y-Axis Lock (Disabled)");
             sender.clientmessage("-- And other powerful tweaks such as, but not limited to, wall hacks, radars, player glow, powerup respawn glow, and invisible pulse/shock beams.");
             //sender.clientmessage("num players: " $ level.game.gameReplicationInfo.numPlayers);
             
             //sender.clientmessage("This mod does not affect harmless preference/FPS-saver tweaks such as simple pulse, no carcass etc");
             //sender.clientmessage("If you know of a big tweak that gets by this mod, please PM the code to me, {PiN}Hai-Ping, at http://forums.prounreal.com/ Thanks and enjoy.");
         }
    }
    
   //VERY IMPORTANT
   if (sender!=none) super.mutate(mutatestr,sender);
}

simulated function tick(float Delta) {
    local playerpawn pp;
    local string yStr, curSpeed;
    local int ySpeedPos;
    
    if (level.netMode!=NM_DedicatedServer) { 
        if (!bHudMutator) registerHudMutator();
        //wait 300 ticks (to get p) and then check for tweaks and set the timer for script to check every 5 seconds.
        if (!bChecked && p != none) {
            if (tickCount > 300) {
                if (p != none) { checkTweaks(); setTimer(5,true); } 
                bChecked = true;
            }
            else tickCount++;
        } 
        
        //Get p n do stuff once
        if (!bGotP) { 
        
            foreach allactors(class'playerpawn',pp) {
                if (pp.myHud != None) p = pp;
            }

            if (p != none) { 
                bGotP=true; 
                /*
                //get mousey
                yStr = p.consoleCommand("get input mouseY");
                ySpeedPos = inStr(caps(yStr), "SPEED=");

                if (ySpeedPos != -1) { 
                    ySpeed = mid(yStr, (ySpeedPos + 6), len(yStr) - (ySpeedPos+6));
                }
                */
            }
        }      
          
    }        
    else {
        //Wait 100 ticks and then set up vars
        if (!bVarsSet) {
            if (serverTickCount > 100) { setVars(); bVarsSet = true; }
            else serverTickCount++;
        }
        
    }
    
    /*
    //KILL ALL EMPTY WEAPONS FROM LEVEL
    foreach allactors(class'weapon', w) {
         if (w.pickupammocount == 0 && w.itemName != "Impact Hammer") {
           w.destroy();
         }      
    }
    */
}

/*
simulated event PostRender(canvas c) {

    local ut_eightball r;
     
     
   
    //Set the mouse y every 200 ticks
    if (yTCount > 200) { 
       
            // -- Caused freezing bug
            //get mousey
            //yStr = p.consoleCommand("get input mouseY");
            //ySpeedPos = inStr(caps(yStr), "SPEED=");

            //if (ySpeedPos != -1) { 
            //    curSpeed = mid(yStr, (ySpeedPos + 6), len(yStr) - (ySpeedPos+6));
            //}

            //if (p!=none && curSpeed != ySpeed)
            
            //if (p != none) { 
            //    p.consoleCommand("set input mouseY axis amousey Speed=" $ ySpeed); 
            //    yTcount = 0; 
            //}
    }
    else yTCount++;
    
    

    
    super.postrender(c);
    
}
*/
simulated function Timer() {
    if (bVarsSet && p != none) checkTweaks();
} 


simulated function checkTweaks() {
  local string tweakStr;
  
    tweakStr = findTweak();

    if (tweakStr != "") { 
     broadcast("*** AntiTweak Alert *** : " $ p.PlayerReplicationInfo.PlayerName $ " was kicked for: " $ tweakStr);
    }
  
}

simulated function string findTweak() {
    local ut_shieldbelt sb;
    local udamage amp;
    local warheadlauncher deemer;
    local healthpack keg;
    local ctfflag flag;
    local ut_invisibility invis;
    local armor2 armor;
    local ut_jumpboots boots;
    local playerpawn aplayer;
    local string tweaksFound;
    
    if (class'texture'.default.bTransparent != bTextureTransparent) return "Wall Hack (Transparent Walls)";
        
    foreach p.level.allactors(class'ut_shieldBelt', sb) {
        if (sb.drawscale > SBDS && SBDS != 0) return "Big SB Tweak" $ " (Details: Server's=" $ SBDS $ " , Player's=" $ SB.drawScale $ ")";
        else if (sb.Mesh != SBMesh && sb.Mesh != none && SBMesh != none) return "Altered SB Mesh Tweak" $ " (Details: Server's=" $ SBMesh $ " , Player's=" $ SB.Mesh $ ")";
    }
    foreach p.level.allactors(class'udamage', amp) {
        if (amp.drawscale > ampDS && AmpDS != 0) return "Big Amp Tweak" $ " (Details: Server's=" $ AmpDS $ " , Player's=" $ Amp.drawScale $ ")";
        else if (amp.Mesh != ampMesh && Amp.Mesh != none && ampMesh != none) return "Altered Powerup Mesh Tweak" $ " (Details: Server's=" $ AmpMesh $ " , Player's=" $ Amp.Mesh $ ")";
    }
    foreach p.level.allactors(class'warheadlauncher', deemer) {
        if (deemer.drawscale > deemerDS && DeemerDS !=0) return "Big Deemer Tweak" $ " (Details: Server's=" $ deemerDS $ " , Player's=" $ deemer.drawScale $ ")";
        else if (deemer.Mesh != deemerMesh && deemerMesh != none && Deemer.Mesh != none && deemer.Mesh != lodMesh'warhead') return "Altered Powerup Mesh Tweak"  $ " (Details: Server's=" $ deemerMesh $ " , Player's=" $ deemer.Mesh $ ")";
    }
    foreach p.level.allactors(class'healthPack', Keg) {
        if (Keg.drawscale > KegDS && KegDS !=0) return "Big Keg Tweak" $ " (Details: Server's=" $ KegDS $ " , Player's=" $ Keg.drawScale $ ")";
        else if (Keg.Mesh != KegMesh && Keg.Mesh != none && KegMesh != none) return "Altered Powerup Mesh Tweak"  $ " (Details: Server's=" $ KegMesh $ " , Player's=" $ keg.mesh $ ")";
    }
    foreach p.level.allactors(class'ut_invisibility', invis) {
        if (invis.drawscale > invisDS && InvisDS !=0) return "Big Invis Tweak" $ " (Details: Server's=" $ InvisDS $ " , Player's=" $ Invis.drawScale $ ")";
        else if (invis.Mesh != invisMesh && invis.Mesh != none && invisMesh != none) return "Altered Powerup Mesh Tweak" $ " (Details: Server's=" $ InvisMesh $ " , Player's=" $ Invis.Mesh $ ")";
    }
    foreach p.level.allactors(class'armor2', armor) {
        if (armor.drawscale > armorDS && ArmorDS !=0) return "Big Armor Tweak" $ " (Details: Server's=" $ ArmorDS $ " , Player's=" $ armor.drawScale $ ")";
        else if (armor.Mesh != ArmorMesh && Armor.Mesh != none && ArmorMesh != none) return "Altered Armor Mesh Tweak" $ ArmorMesh $ " , Player's=" $ armor.Mesh $ ")";
    }
    foreach p.level.allactors(class'ut_jumpboots', boots) {
        if (boots.drawscale > bootsDS && BootsDS !=0) return "Big Boots Tweak" $ " (Details: Server's=" $ bootsDS $ " , Player's=" $ boots.drawScale $ ")";
        else if (boots.Mesh != bootsMesh && boots.Mesh != none && bootsMesh != none) return "Altered Boots Mesh Tweak" $ bootsMesh $ " , Player's=" $ boots.Mesh $ ")";
    }
    foreach p.level.allactors(class'ctfflag', flag) {
        if (flag.drawscale > flagDrawScale && flagDrawScale !=0) return "Big Flags Tweak" $ " (Details: Server's=" $ flagDrawScale $ " , Player's=" $ Flag.drawScale $ ")";
        else if (flag.Mesh != FlagMesh && flag.Mesh != none && flagMesh != none) return "Altered Flag Mesh Tweak" $ " (Details: Server's=" $ flagMesh $ " , Player's=" $ Flag.Mesh $ ")";
        else if (flag.lightRadius != FlagLtRad && !flag.bheld && FlagLtRad != 0) return "Big Flag Glow Tweak" $ " (Details: Server's=" $ flagLtRad $ " , Player's=" $ flag.lightRadius $ ")";
    }
    foreach p.level.allactors(class'playerpawn', aplayer) {
        if (aplayer.lightRadius > 10) return "Big Player Glow Tweak" $ " (Details: Server's=" $ TournPlayerLR $ " , Player's=" $ aplayer.LightRadius $ ")";
    }
    
    
    if (class'UT_shieldBeltEffect'.default.lightType != SBEffectLightType && SBEffectLightType != 0) return "Shieldbelt Person Glow Tweak (Glow on a belted person which can be seen through walls. A Form of Radar.)";

    if (class'Translocatortarget'.default.lightBrightness != TransTargetLightBrightness) return "Translocator Glow (Large ring around trans; can be seen through walls) - A Form of Radar";
    else if (class'Translocatortarget'.default.soundradius != TransTargetSoundRadius && TransTargetSoundRadius != 0) return "Translocator Sound Radius Tweak - Auditory Radar (Details: Server's=" $ TransTargetSoundRadius $ " , Player's=" $  class'Translocatortarget'.default.soundradius $ ")";

    //else if (class'Translocatortarget'.default.lightType != TransTargetLightType && TransTargetLightType != 0) return "Translocator Light Type Altered)";
    //else if (class'Translocatortarget'.default.LightRadius != TransTargetLightRadius && TransTargetLightRadius != 0) return "Translocator Light Radius Tweak - A Form of Radar (Details: Server's=" $ TransTargetLightRadius $ " , Player's=" $  class'Translocatortarget'.default.LightRadius $ ")";
    //else if (class'Translocatortarget'.default.LightEffect != TransTargetLightEffect && TransTargetLightEffect != 0) return "Translocator Light Effect Changed)";

    if (class'enhancedRespawn'.default.lightRadius != enhancedRespawnLightRadius && enhancedRespawnLightRadius != 0) return "Powerup Respawn Glow Tweak (Shows when powerups come up)";
    else if (class'enhancedRespawn'.default.lightEffect != EnhancedRespawnLightEffect && EnhancedRespawnLightEffect != 0) return "Powerup Respawn Glow Tweak (Shows when powerups come up)";
    else if (class'enhancedRespawn'.default.lifeSpan != enhancedRespawnLifeSpan && enhancedRespawnLifeSpan != 0) return "Powerup Respawn Glow Tweak (Shows when powerups come up)";
    else if (class'enhancedRespawn'.default.DrawType != enhancedRespawnDrawType && enhancedRespawnDrawType != 0) return "Powerup Respawn Glow Tweak (Shows when powerups come up)";
      

    if (class'fire.watertexture'.default.bInvisible != bWaterInvis) return "No Water Tweak";
    else if (class'fire.wetTexture'.default.bInvisible != bFireWetTextureInvis) return "No Water Tweak";   
    
    if (class'playerpawn'.default.bunlit != playerBunlit ) return "Bright Player Tweak (Makes players bright and unaffected by shadows)";
    else if (class'tmale1'.default.bunlit != playerBunlit ) return "Bright Player Tweak (Makes players bright and unaffected by shadows)";
    else if (class'tmale2'.default.bunlit != playerBunlit ) return "Bright Player Tweak (Makes players bright and unaffected by shadows)";
    else if (class'tfemale1'.default.bunlit != playerBunlit ) return "Bright Player Tweak (Makes players bright and unaffected by shadows)";        
    else if (class'tfemale2'.default.bunlit != playerBunlit ) return "Bright Player Tweak (Makes players bright and unaffected by shadows)";
    else if (class'tournamentPlayer'.default.bunlit != playerBunlit ) return "Bright Player Tweak (Makes players bright and unaffected by shadows)";   


    else if (class'BOT'.default.lighttype != LT_None ) return "Bright Player Tweak (Makes players bright and unaffected by shadows)";
    else if (class'tfemale1'.default.Lighttype  != LT_None) return "Bright Player Tweak (Makes players bright and unaffected by shadows)";        
    else if (class'tfemale2'.default.Lighttype  != LT_None) return "Bright Player Tweak (Makes players bright and unaffected by shadows)";     
  //else if (class'Tskaarj'.default.Lighttype  != LT_None) return "Bright Player Tweak (Makes players bright and unaffected by shadows)";     
  //else if (class'Tnali'.default.Lighttype  != LT_None) return "Bright Player Tweak (Makes players bright and unaffected by shadows)";     
  //else if (class'Tcow'.default.Lighttype  != LT_None) return "Bright Player Tweak (Makes players bright and unaffected by shadows)";     
    else if (class'TMale1'.default.Lighttype  != LT_None) return "Bright Player Tweak (Makes players bright and unaffected by shadows)";     
    else if (class'TMale2'.default.Lighttype  != LT_None) return "Bright Player Tweak (Makes players bright and unaffected by shadows)";     

    if (class'translocouteffect'.default.texture == texture'botpack.womanbelt') return "Transloc Person Outline Tweak";
      
    if (class'ShockBeam'.default.drawScale != ShockBeamDS && ShockBeamDS != 0) return "Shockbeam Tweak - ((Details: Drawscale - Server's=" $ ShockBeamDS $ " , Player's=" $ class'ShockBeam'.default.drawScale $ ")";
    else if (class'ShockBeam'.default.lifespan != ShockBeamLifeSpan && ShockBeamLifeSpan != 0) return "Shockbeam Tweak - ((Details: Lifespan - Server's=" $ ShockBeamLifeSpan $ " , Player's=" $ class'ShockBeam'.default.LifeSpan $ ")";
    else if (class'ShockBeam'.default.mesh != ShockBeamMesh && ShockBeamMesh != none) return "Shockbeam Tweak - Mesh Changed";

    
    if (class'pbolt'.default.mesh != PBoltMesh && PBoltMesh != none) return "Pulse Tweak - Mesh Changed";
    else if (class'starterBolt'.default.Mesh != StarterBoltMesh && StarterBoltMesh != none) return "Pulse Tweak - Mesh Changed";
    
    if (class'plasmahit'.default.texture != PlasmaHitTexture && PlasmaHitTexture != none) return "Pulse tweak - Texture Changed To Indicate Hit";
    
    if (class'pbolt'.default.DrawScale != PBoltDS && PBoltDS != 0) return "Pulse Tweak - Pbolt changed ((Details: DrawScale - Server's=" $ PboltDS $ " , Player's=" $ class'pbolt'.default.drawScale $ ")";
    else if (class'starterbolt'.default.DrawScale != StarterBoltDS && StarterBoltDS != 0) return "Pulse Tweak - Starterbolt changed ((Details: DrawScale - Server's=" $ starterBoltDS $ " , Player's=" $ class'starterBolt'.default.drawScale $ ")";
    
    if (class'ut_spriteSmokePuff'.default.bHidden != bRocketPuffHidden) return "No Smoke Tweak";
    else if (class'LightSmokeTrail'.default.bHidden != bRocketTrailHidden) return "No Smoke Tweak";
    else if (class'utSmokeTrail'.default.bHidden != bUtSmokeTrail) return "No Smoke Tweak";
    else if (class'utSmokeTrail'.default.drawScale != UTSmokeTrailDS && UTSmokeTrailDS != 0) return "No Smoke Tweak - ((Details: Server's=" $ UTSmokeTrailDS $ " , Player's=" $ class'utSmokeTrail'.default.drawScale $ ")";
       
    return "";
}


simulated function broadcast(string s) {
    
    p.consolecommand("mutate AntiTweak broadcast " $ s);
}

defaultproperties
{
    version="5.2VM"
    bAlwaysRelevant=True
    RemoteRole=2
    bNetInitial=True
}
